import type { RspackPluginFunction, RspackPluginInstance } from "@rspack/core";
import { Compiler, MultiCompiler, MultiRspackOptions, MultiStats, RspackOptions, Stats } from "@rspack/core";
import yargs from "yargs";
import { RspackBuildCLIOptions, RspackCLIColors, RspackCLILogger, RspackCLIOptions } from "./types";
type Command = "serve" | "build";
export declare class RspackCLI {
    colors: RspackCLIColors;
    program: yargs.Argv;
    constructor();
    createCompiler(options: RspackBuildCLIOptions, rspackCommand: Command, callback?: (e: Error | null, res?: Stats | MultiStats) => void): Promise<MultiCompiler | Compiler | null>;
    createColors(useColor?: boolean): RspackCLIColors;
    getLogger(): RspackCLILogger;
    run(argv: string[]): Promise<void>;
    registerCommands(): Promise<void>;
    buildConfig(item: RspackOptions | MultiRspackOptions, options: RspackBuildCLIOptions, command: Command): Promise<RspackOptions | MultiRspackOptions>;
    loadConfig(options: RspackCLIOptions): Promise<RspackOptions | MultiRspackOptions>;
    isMultipleCompiler(compiler: Compiler | MultiCompiler): compiler is MultiCompiler;
    isWatch(compiler: Compiler | MultiCompiler): boolean;
}
export declare function defineConfig(config: RspackOptions): RspackOptions;
export declare function definePlugin(plugin: RspackPluginFunction): RspackPluginFunction;
export declare function definePlugin(plugin: RspackPluginInstance): RspackPluginInstance;
export {};
